Loading...
Searching...
No Matches
AVBPrint Struct Reference
libavutil » Data Structures » AVBPrint

Buffer to print data progressively. More...

`#include <libavutil/bprint.h>`

## Data Fields

char * | str
| string so far
unsigned | len
| length so far
unsigned | size
| allocated memory
unsigned | size_max
| maximum allocated memory
char | reserved_internal_buffer [1]

## Detailed Description

Buffer to print data progressively.

The string buffer grows as necessary and is always 0-terminated. The content of the string is never accessed, and thus is encoding-agnostic and can even hold binary data.

Small buffers are kept in the structure itself, and thus require no memory allocation at all (unless the contents of the buffer is needed after the structure goes out of scope). This is almost as lightweight as declaring a local `char buf[512]`.

The length of the string can go beyond the allocated size: the buffer is then truncated, but the functions still keep account of the actual total length.

In other words, AVBPrint.len can be greater than AVBPrint.size and records the total length of what would have been to the buffer if there had been enough memory.

Append operations do not need to be tested for failure: if a memory allocation fails, data stop being appended to the buffer, but the length is still updated. This situation can be tested with av_bprint_is_complete().

The AVBPrint.size_max field determines several possible behaviours:

- `size_max = -1` (= `UINT_MAX`) or any large value will let the buffer be reallocated as necessary, with an amortized linear cost.
- `size_max = 0` prevents writing anything to the buffer: only the total length is computed. The write operations can then possibly be repeated in a buffer with exactly the necessary size (using `size_init = size_max = len + 1`).
- `size_max = 1` is automatically replaced by the exact size available in the structure itself, thus ensuring no dynamic memory allocation. The internal buffer is large enough to hold a reasonable paragraph of text, such as the current paragraph.

Definition at line 99 of file bprint.h.

## Field Documentation

## str

char* AVBPrint::str

string so far

Definition at line 99 of file bprint.h.

## len

unsigned AVBPrint::len

length so far

Definition at line 99 of file bprint.h.

Referenced by av_bprint_is_complete().

## size

unsigned AVBPrint::size

allocated memory

Definition at line 99 of file bprint.h.

Referenced by av_bprint_is_complete().

## size_max

unsigned AVBPrint::size_max

maximum allocated memory

Definition at line 99 of file bprint.h.

## reserved_internal_buffer

char AVBPrint::reserved_internal_buffer[1]

Definition at line 99 of file bprint.h.

The documentation for this struct was generated from the following file:

- libavutil/bprint.h